

#include <mega8.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#include <delay.h>

#define KEY_UP 1
#define KEY_DN 2
#define KEY_NEXT 4
#define KEY_NONE 0


typedef unsigned char u8;

// Timer2 overflow interrupt service routine
interrupt [TIM2_OVF] void timer2_ovf_isr(void)
{
// Place your code here

}


// ,       
u8 get_key(void){
   u8 temp = ~(PINC & (KEY_UP | KEY_DN | KEY_NEXT));
   delay_ms(15);
   if(temp != (~(PINC & (KEY_UP | KEY_DN | KEY_NEXT))))
      return KEY_NONE;
   else
      return temp;
}

static void mode1(void){
   u8 key;
   while(1){
      key = get_key();
      switch(key){
      case KEY_UP: if(OCR2 < 255) OCR2++;
         break;
      case KEY_DN: if(OCR2) OCR2--;
         break;
      case KEY_NEXT:
         return;
      }
   }
}

static void mode2(void){
   u8 key;
   static signed char reverse;
   while(1){
      key = get_key();
      if(key == KEY_NEXT) return;
      if(OCR2 == 255) reverse = -1;
      if(OCR2 == 0) reverse = 1;
      OCR2 += reverse;
      delay_ms(100);
   }
}

static void mode3(void){
   while(get_key() != KEY_NEXT);
}


void main(void)
{
// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=Out Func2=In Func1=In Func0=In
// State7=T State6=T State5=T State4=T State3=0 State2=T State1=T State0=T
PORTB=0x00;
DDRB =(1<<3);
// Port C initialization
// Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
// State6=T State5=T State4=T State3=T State2=P State1=P State0=P
PORTC=0xff;
DDRC=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: 125,000 kHz
// Mode: Fast PWM top=FFh
// OC2 output: Non-Inverted PWM
ASSR=0x00;
TCCR2=0x69;
TCNT2=0x00;
OCR2=0x00;


// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x40;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

while(1){
      mode1();
      mode2();
      mode3();
   }
}
